ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
(Generate patch)

Comparing deliantra/server/utils/cfutil.in (file contents):
Revision 1.3 by root, Wed Mar 7 18:04:44 2007 UTC vs.
Revision 1.55 by root, Sun Aug 19 13:45:43 2007 UTC

6my $exec_prefix = "@exec_prefix@"; 6my $exec_prefix = "@exec_prefix@";
7my $datarootdir = "@datarootdir@"; 7my $datarootdir = "@datarootdir@";
8my $DATADIR = "@datadir@/@PACKAGE@"; 8my $DATADIR = "@datadir@/@PACKAGE@";
9 9
10my $CONVERT = "@CONVERT@"; 10my $CONVERT = "@CONVERT@";
11my $IDENTIFY = "@IDENTIFY@"; 11#my $IDENTIFY = "@IDENTIFY@";
12my $OPTIPNG = "@OPTIPNG@"; 12my $OPTIPNG = "@OPTIPNG@";
13my $RSYNC = "@RSYNC@"; 13my $RSYNC = "@RSYNC@";
14my $PNGNQ = "@PNGNQ@";
14 15
15use Getopt::Long; 16use Getopt::Long;
16use Coro::Event; 17use Coro::Event;
17use AnyEvent; 18use AnyEvent;
18use IO::AIO (); 19use IO::AIO ();
19use File::Temp; 20use File::Temp;
20use Crossfire; 21use Crossfire;
21use Coro; 22use Coro;
22use Coro::AIO; 23use Coro::AIO;
24use Coro::Util;
23use POSIX (); 25use POSIX ();
26use Digest::MD5;
27use Carp;
28use Coro::Channel;
29use Coro::Storable; $Storable::canonical = 1;
30
31$SIG{QUIT} = sub { Carp::cluck "QUIT" };
24 32
25sub usage { 33sub usage {
26 warn <<EOF; 34 warn <<EOF;
27Usage: cfutil [-v] [-q] [--force] [--cache] 35Usage: cfutil [-v] [-q] [--force] [--cache]
28 [--install-arch path] 36 [--install-arch path]
40my $CACHE = 0; 48my $CACHE = 0;
41my $FORCE; 49my $FORCE;
42my $TMPDIR = "/tmp/cfutil$$~"; 50my $TMPDIR = "/tmp/cfutil$$~";
43my $TMPFILE = "aaaa0"; 51my $TMPFILE = "aaaa0";
44 52
53our %COLOR = (
54 black => 0,
55 white => 1,
56 navy => 2,
57 red => 3,
58 orange => 4,
59 blue => 5,
60 darkorange => 6,
61 green => 7,
62 lightgreen => 8,
63 grey => 9,
64 brown => 10,
65 gold => 11,
66 tan => 12,
67);
68
45END { system "rm", "-rf", $TMPDIR } 69END { system "rm", "-rf", $TMPDIR }
46 70
47Event->signal (signal => "INT", cb => sub { exit 1 }); 71Event->signal (signal => "INT", cb => sub { exit 1 });
48Event->signal (signal => "TERM", cb => sub { exit 1 }); 72Event->signal (signal => "TERM", cb => sub { exit 1 });
49 73
66} 90}
67 91
68sub inst_maps($) { 92sub inst_maps($) {
69 my (undef, $path) = @_; 93 my (undef, $path) = @_;
70 94
71 print "installing '$path' to '$DATADIR/maps'\n\n"; 95 print "\nInstalling '$path' to '$DATADIR/maps'\n\n";
72 96
73 if (!-f "$path/regions") { 97 if (!-f "$path/regions") {
74 warn "'$path' does not look like a maps directory ('regions' file is missing).\n"; 98 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
75 exit 1 unless $FORCE; 99 exit 1 unless $FORCE;
76 } 100 }
77 101
78 system $RSYNC, "-av", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded"; 102 system $RSYNC, "-a", "--chmod=u=rwX,go=rX", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded"
103 and die "map installation failed.\n";
104
105 print "maps installed successfully.\n";
79} 106}
80 107
81{ 108{
82 our @PNG; 109 our %ANIMINFO;
110 our %FACEINFO;
111 our %RESOURCE;
83 our @ARC; 112 our @ARC;
113 our %ARC;
114 our $TRS;
84 our $NFILE; 115 our $NFILE;
116 our $PATH;
85 117
86 our (@png, @trs, @arc); # files we are interested in 118 our $QUANTIZE = "+dither -colorspace RGB -colors 256";
87 119
120 our $c_arc = new Coro::Channel;
121 our $c_trs = new Coro::Channel;
122 our $c_res = new Coro::Channel;
123
124 our @c_png;
125
88 sub commit_png { 126 sub commit_png($$$) {
89 my ($name, $data) = @_; 127 my ($name, $data, $T) = @_;
90 #warn "$name: commited\n"; 128
129 $FACEINFO{$name}{"data$T"} = $data;
91 } 130 }
92 131
93 sub process_png { 132 sub process_png {
94 while (@png) { 133 while (@c_png) {
95 my $path = pop @png; 134 my ($path, $delete) = @{pop @c_png};
96 135
97 my $png; 136 my $png;
98 aio_lstat $path; 137 aio_lstat $path;
99 my ($size, $mtime) = (stat _)[7,9]; 138 my ($size, $mtime) = (stat _)[7,9];
100 139
101 if (0 > aio_load $path, $png) { 140 if (0 > aio_load $path, $png) {
102 warn "$path: $!, skipping.\n"; 141 warn "$path: $!, skipping.\n";
103 return; 142 next;
104 } 143 }
105 144
145 my $stem = $path;
146 my $T;
147
148 if ($stem =~ s/\.32x32\.png~?$//) {
149 $T = 32;
150 } elsif ($stem =~ s/\.64x64\.png~?$//) {
151 $T = 64;
152 } else {
153 warn "$path: weird filename, skipping.\n";
154 next;
155 }
156
106 # quickly extratc width and height of the (necessarily PNG) image 157 # quickly extract width and height of the (necessarily PNG) image
107 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) { 158 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) {
108 warn "$path: not a recongized png file, skipping.\n"; 159 warn "$path: not a recognized png file, skipping.\n";
109 return; 160 next;
110 } 161 }
111 162
112 my ($w, $h) = unpack "NN", $1; 163 my ($w, $h) = unpack "NN", $1;
113
114 (my $face = $path) =~ s/^.*\///;
115 my $T = 32;
116
117 unless ($face =~ s/\.base\.(...)\.png$/.$1/) {
118 warn "$path: weird filename, skipping.\n";
119 return;
120 }
121 164
122 if ($w < $T || $h < $T) { 165 if ($w < $T || $h < $T) {
123 warn "$path: too small ($w $h), skipping.\n"; 166 warn "$path: too small ($w $h), skipping.\n";
124 return; 167 next;
125 } 168 }
126 169
127 if ($w % $T || $h % $T) { 170 if ($w % $T || $h % $T) {
128 warn "$path: weird png size ($w $h), skipping.\n"; 171 warn "$path: weird png size ($w $h), skipping.\n";
129 return; 172 next;
173 }
174
175 (my $base = $stem) =~ s/^.*\///;
176
177 my $fi = $FACEINFO{$base};
178 unless ($fi) {
179 warn "$path: <$base> not referenced by any archetype, skipping.\n";
180 next;
181 }
182
183 my $arc = $FACEINFO{$base}{arc}
184 or die "FATAL: internal error, cannot continue";
185
186 unless ($path =~ /~$/) {
187 # possibly enlarge
188 if (0 > aio_stat "$stem.64x64.png") {
189 my $other = "$stem.64x64.png~";
190
191 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
192 fork_sub {
193 my $CROP;
194 my $SRC = "png:\Q$path\E";
195
196 my $is_floor = $arc->{is_floor};
197 my $is_wall = 0;
198
199 my ($wall_pfx, $wall_dir, $wall_sfx);
200
201 if (
202 !$is_floor
203 && !$arc->{alive}
204 && $arc->{move_block} eq "all"
205 && $path =~ /^(.*_)([0-9A-F])(\.x11.*\.png)$/
206 ) {
207 ($wall_pfx, $wall_dir, $wall_sfx) = ($1, hex $2, $3);
208
209 unless (grep { !-e sprintf "%s%X%s", $wall_pfx, $_, $wall_sfx } 0..15) {
210 $is_wall = 1;
211 }
212 }
213
214 if ($is_wall || $is_floor) {
215 # add a 4px border and add other images around it
216 $CROP = "-shave 8x8 +repage";
217
218 $w += 8;
219 $h += 8;
220
221 $SRC = "-size ${w}x${h} xc:transparent";
222 $SRC .= " png:\Q$path\E -geometry +4+4 -composite";
223
224 # 8 surrounding images
225 for (
226 # x y b r0 r1
227 [-1, -1, 0, 6],
228 [ 0, -1, 1, 10, 14],
229 [+1, -1, 0, 12],
230
231 [-1, 0, 8, 5, 7],
232 #
233 [+1, 0, 2, 5, 13],
234
235 [-1, +1, 0, 3],
236 [ 0, +1, 4, 10, 11],
237 [+1, +1, 0, 9],
238 ) {
239 my ($x, $y, $d, $r0, $r1) = @$_;
240
241 my $tile = $is_floor ? $path
242 : $is_wall ? sprintf "%s%X%s", $wall_pfx, ($wall_dir & $d) ? $r1 : $r0, $wall_sfx
243 : die;
244
245 $SRC .= sprintf " png:%s -geometry %+d%+d -composite",
246 "\Q$tile",
247 $x * ($w - 8) + 4,
248 $y * ($h - 8) + 4;
249 }
250 }
251
252 system "convert -depth 8 $SRC rgba:-"
253 . "| $exec_prefix/bin/cfhq2xa $w $h 0"
254 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $CROP $QUANTIZE -quality 00 png32:\Q$other\E~"
255 and die "convert/cfhq2xa pipeline error: status $? ($!)";
256 system $OPTIPNG, "-i0", "-q", "$other~";
257 die "$other~ has zero size, aborting." unless -s "$other~";
258 rename "$other~", $other;
259 };
260 }
261
262 push @c_png, [$other, !$CACHE];
130 } 263 }
131 264
265 # possibly scale down
266 if (0 > aio_stat "$stem.32x32.png") {
267 my $other = "$stem.32x32.png~";
268
269 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
270 fork_sub {
271 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~";
272 system $OPTIPNG, "-i0", "-q", "$other~";
273
274 # reduce smoothfaces >10000 bytes
275 if ($stem =~ /_S\./ && (-s "$other~") > 10000) {
276 my $ncolor = 256;
277 while () {
278 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E";
279 system $OPTIPNG, "-i0", "-q", "$other~~";
280 last if 10000 > -s "$other~~";
281 $ncolor = int $ncolor * 0.9;
282 $ncolor > 8 or die "cannot reduce filesize to < 10000 bytes";
283 }
284
285 printf "reduced %s from %d to %d bytes using %d colours.\n",
286 $other, -s "$other~", -s "$other~~", $ncolor
287 if $VERBOSE >= 2;
288 rename "$other~~", "$other~";
289 }
290
291 die "$other~ has zero size, aborting." unless -s "$other~";
292 rename "$other~", $other;
293 };
294 }
295
296 #warn "scaled down $path to $other\n";#d#
297 push @c_png, [$other, !$CACHE];
298 }
299 }
300
301 (my $face = $stem) =~ s/^.*\///;
302
303 # split all bigfaces, but avoid smoothfaces (*_S)
132 if (($w > $T || $h > $T) && $face !~ /_S\./) { 304 if (($w > $T || $h > $T) && $face !~ /_S\./) {
133 # split 305 # split
134 my @tile; 306 my @tile;
135 for my $x (0 .. (int $w / $T) - 1) { 307 for my $x (0 .. (int $w / $T) - 1) {
136 for my $y (0 .. (int $h / $T) - 1) { 308 for my $y (0 .. (int $h / $T) - 1) {
149 (map { 321 (map {
150 ( 322 (
151 "(", 323 "(",
152 "+clone", 324 "+clone",
153 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T), 325 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T),
326 "+repage",
327 -quality => "00",
154 -write => "png:$_->[2]~", 328 -write => "png32:$_->[2]~",
155 "+delete", 329 "+delete",
156 ")", 330 ")",
157 ) 331 )
158 } @todo), 332 } @todo),
159 "null:"; 333 "null:";
163 close $convert; 337 close $convert;
164 338
165 # pass 2, optimise, and rename 339 # pass 2, optimise, and rename
166 for (@todo) { 340 for (@todo) {
167 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~"; 341 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~";
342 die "$_->[2]~ has zero size, aborting." unless -s "$_->[2]~";
168 rename "$_->[2]~", $_->[2]; 343 rename "$_->[2]~", $_->[2];
169 } 344 }
170 }; 345 };
171 } 346 }
172 347
176 351
177 if (0 > aio_load $file, $tile) { 352 if (0 > aio_load $file, $tile) {
178 die "$path: unable to read tile +$x+$y, aborting.\n"; 353 die "$path: unable to read tile +$x+$y, aborting.\n";
179 } 354 }
180 IO::AIO::aio_unlink $file unless $CACHE; 355 IO::AIO::aio_unlink $file unless $CACHE;
181 commit_png $x|$y ? "$face+$x+$y" : $face, $tile; 356 commit_png $x|$y ? "$face+$x+$y" : $face, $tile, $T;
182 } 357 }
183 } else { 358 } else {
184 # use as-is (either small, use smooth) 359 # use as-is (either small, use smooth)
185 commit_png $face, $png; 360 commit_png $face, $png, $T;
186 } 361 }
362
363 aio_unlink $path if $delete;
187 } 364 }
188 } 365 }
189 366
190 sub process_arc { 367 sub process_arc {
191 while (@arc) { 368 while (my $job = $c_arc->get) {
192 my ($dir, $file) = @{pop @arc}; 369 my ($dir, $file) = @$job;
193 370
194 my $arc; 371 my $arc;
195 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/ 372 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/
373
196 my $arc = read_arch "$dir/$file"; 374 my $arc = read_arch "$dir/$file";
375 for my $o (values %$arc) {
376 push @ARC, $o;
377 for (my $m = $o; $m; $m = $m->{more}) {
378 $ARC{$m->{_name}} = $m;
379 }
380
381 $o->{editor_folder} = $dir;
382
383 my $visibility = delete $o->{visibility};
384 my $magicmap = delete $o->{magicmap};
385
386 # find upper left corner :/
387 # omg, this is sooo broken
388 my ($dx, $dy);
389 for (my $o = $o; $o; $o = $o->{more}) {
390 $dx = $o->{x} if $o->{x} < $dx;
391 $dy = $o->{y} if $o->{y} < $dy;
392 }
393
394 for (my $o = $o; $o; $o = $o->{more}) {
395 my $x = $o->{x} - $dx;
396 my $y = $o->{y} - $dy;
397
398 my $ext = $x|$y ? "+$x+$y" : "";
399
400 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face};
401
402 $visibility = delete $o->{visibility} if exists $o->{visibility};
403 $magicmap = delete $o->{magicmap} if exists $o->{magicmap};
404
405 my $anim = delete $o->{anim};
406
407 if ($anim) {
408 # possibly add $ext to the animation name to avoid
409 # the need to specify archnames for all parts
410 # of a multipart archetype.
411 $o->{animation} = "$o->{_name}";
412 my $facings = 1;
413 my @frames;
414
415 for (@$anim) {
416 if (/^facings\s+(\d+)/) {
417 $facings = $1*1;
418 } elsif (/^blank.x11$|^empty.x11$/) {
419 push @frames, $_;
420 } else {
421 push @frames, "$_$ext";
422 }
423 }
424
425 $ANIMINFO{$o->{animation}} = {
426 facings => $facings,
427 frames => \@frames,
428 };
429 }
430
431 for my $face ($o->{face} || (), @{$anim || []}) {
432 next if $face =~ /^facings\s|^blank.x11$|^empty.x11$/;
433
434 my $info = $FACEINFO{$face} ||= {};
435
436 $info->{arc} = $o;
437 $info->{visibility} = $visibility if defined $visibility;
438 $info->{magicmap} = $magicmap if defined $magicmap;
439 }
440
441 if (my $smooth = delete $o->{smoothface}) {
442 my %kv = split /\s+/, $smooth;
443 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support
444 while (my ($face, $smooth) = each %kv) {
445 $FACEINFO{$smooth}{arc} = $o;
446
447 $FACEINFO{$face}{smooth} = $smooth;
448 $FACEINFO{$face}{smoothlevel} = $level;
449 }
450 }
451 }
452 }
197 } 453 }
198 } 454 }
199 455
200 sub process_trs { 456 sub process_trs {
201 while (@trs) { 457 while (my $job = $c_trs->get) {
202 my ($dir, $file) = @{pop @trs}; 458 my ($dir, $file) = @$job;
459 my $path = "$dir/$file";
460
461 my $trs;
462 if (0 > aio_load $path, $trs) {
463 warn "$path: $!, skipping.\n";
464 next;
465 }
466
467 $TRS .= $trs;
468 }
469 }
470
471 my %FILECACHE;
472
473 sub load_cached($;$) {
474 unless (exists $FILECACHE{$_[0]}) {
475 my $data;
476 if (0 < aio_load $_[0], $data) {
477 if ($_[1]) {
478 $data = eval { $_[1]->($data) };
479 warn "$_[0]: $@" if $@;
480 }
481 }
482
483 $FILECACHE{$_[0]} = $data;
484 }
485
486 $FILECACHE{$_[0]}
487 }
488
489 sub process_res {
490 while (my $job = $c_res->get) {
491 my ($dir, $file, $type) = @$job;
492
493 my $data;
494 aio_load "$dir/$file", $data;
495
496 my $meta = load_cached "$dir/meta", sub { JSON::XS::from_json shift };
497
498 next if $meta && !exists $meta->{$file};
499
500 $meta = {
501 %{ $meta->{"" } || {} },
502 %{ $meta->{$file} || {} },
503 };
504
505 if ($meta->{license} =~ s/^#//) {
506 $meta->{license} = ({
507 "pd" => "Public Domain",
508 "gpl" => "GNU General Public License, version 3.0 or any later",
509 "cc/by/2.0" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.0/",
510 "cc/by/2.5" => "Licensed under Creative Commons Attribution 2.5 http://creativecommons.org/licenses/by/2.5/",
511 "cc/by/3.0" => "Licensed under Creative Commons Attribution 3.0 http://creativecommons.org/licenses/by/3.0/",
512 })->{$meta->{license}}
513 || warn "$dir/$file: license tag '$meta->{license}' not found.";
514 }
515
516 $file =~ s/\.res$//;
517 $file =~ s/\.(ogg|wav|jpg|png)$//;
518
519 substr $dir, 0, 1 + length $PATH, "";
520
521 $RESOURCE{"$dir/$file"} = {
522 type => (delete $meta->{type}) || $type,
523 data => $data,
524 chksum => (Digest::MD5::md5 $data),
525 %$meta ? (meta => $meta) : (),
526 };
203 } 527 }
204 } 528 }
205 529
206 sub find_files; 530 sub find_files;
207 sub find_files { 531 sub find_files {
212 my ($dirs, $nondirs) = @_; 536 my ($dirs, $nondirs) = @_;
213 537
214 find_files "$path/$_" 538 find_files "$path/$_"
215 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs; 539 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs;
216 540
541 my $dir = $path;
542 substr $dir, 0, 1 + length $PATH, "";
543
217 for my $file (@$nondirs) { 544 for my $file (@$nondirs) {
545 if ($dir =~ /^music(?:\/|$)/) {
546 $c_res->put ([$path, $file, 3]) # FT_MUSIC
547 if $file =~ /\.(ogg)$/;
548
549 } elsif ($dir =~ /^sound(?:\/|$)/) {
550 $c_res->put ([$path, $file, 5]) # FT_SOUND
551 if $file =~ /\.(wav|ogg)$/;
552
553 } elsif ($dir =~ /^res(?:\/|$)/) {
554 $c_res->put ([$path, $file, 0]) # FT_FACE
555 if $file =~ /\.(jpg|png)$/;
556 $c_res->put ([$path, $file, 7]) # FT_RSRC
557 if $file =~ /\.(res)$/;
558
218 if ($file =~ /\.png$/) { 559 } elsif ($file =~ /\.png$/) {
219 push @png, "$path/$file"; 560 push @c_png, ["$path/$file", 0];
561
220 } elsif ($file =~ /\.trs$/) { 562 } elsif ($file =~ /\.trs$/) {
221 push @trs, [$path, $file]; 563 $c_trs->put ([$path, $file]);
564
222 } elsif ($file =~ /\.arc$/) { 565 } elsif ($file =~ /\.arc$/) {
223 push @arc, [$path, $file]; 566 $c_arc->put ([$path, $file]);
567
224 } else { 568 } else {
225 warn "ignoring $path/$file\n" if $VERBOSE >= 2; 569 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
226 } 570 }
227 } 571 }
228 }; 572 };
229 } 573 }
230 574
231 sub inst_arch($) { 575 sub inst_arch($) {
232 my (undef, $path) = @_; 576 my (undef, $path) = @_;
233 577
578 $PATH = $path;
579
580 print "\n",
234 print "installing '$path' to '$DATADIR'\n\n"; 581 "Installing '$path' to '$DATADIR'\n",
582 "\n",
583 "This can take a long time if you run this\n",
584 "for the first time or do not use --cache.\n",
585 "\n",
586 "Unless you run verbosely, all following warning\n",
587 "or error messages indicate serious problems.\n",
588 "\n";
235 589
236 if (!-d "$path/treasures") { 590 if (!-d "$path/treasures") {
237 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n"; 591 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n";
238 exit 1 unless $FORCE; 592 exit 1 unless $FORCE;
239 } 593 }
240 594
595 print "scanning files...\n" if $VERBOSE;
596
241 find_files $path; 597 find_files $path;
598
599 my @a_arc = map +(async \&process_arc), 1..2;
600 my @a_res = map +(async \&process_res), 1..2;
601 my @a_trs = map +(async \&process_trs), 1..2;
602
242 IO::AIO::flush; 603 IO::AIO::flush;
243 604
244 $_->join for ( 605 $c_res->put (undef) for @a_res;
245 (async \&process_png), (async \&process_png), 606 $c_arc->put (undef) for @a_arc;
246 (async \&process_trs), (async \&process_trs), 607 $c_trs->put (undef) for @a_trs;
247 (async \&process_arc), (async \&process_arc), 608
609 print "start file scan, arc, res processing...\n" if $VERBOSE;
610
611 $_->join for @a_arc; # need to parse all archetypes before png processing
612
613 print "end arc, start png processing...\n" if $VERBOSE;
614
615 # four png crunchers work fine for my 2x smp machine
616 my @a_png = map +(async \&process_png), 1..4;
617
618 $_->join for (@a_trs, @a_res, @a_png);
619
620 print "scanning done, processing results...\n" if $VERBOSE;
248 ); 621 {
622 # remove path prefix from editor_folder
623 substr $_->{editor_folder}, 0, 1 + length $path, ""
624 for values %ARC;
249 625
250 die "--install-arch not yet implemented\n"; 626 print "resolving inheritance tree...\n" if $VERBOSE;
627 # resolve inherit
628 while () {
629 my $progress;
630 my $loop;
631
632 for my $o (values %ARC) {
633 if (my $other = $o->{inherit}) {
634 if (my $s = $ARC{$other}) {
635 if ($s->{inherit}) {
636 $loop = $s;
637 } else {
638 delete $o->{inherit};
639 my %s = %$s;
640 delete @s{qw(_name more name name_pl)};
641 %$o = ( %s, %$o );
642 ++$progress;
643 }
644 } else {
645 warn "'$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n";
646 delete $ARC{$o->{_name}};
647 }
648 }
649 }
650
651 unless ($progress) {
652 die "inheritance loop detected starting at archetype '$loop->{_name}', aborting.\n"
653 if $loop;
654
655 last;
656 }
657 }
658
659 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit
660 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC;
661
662 print "writing archetypes...\n" if $VERBOSE;
663 open my $fh, ">:utf8", "$DATADIR/archetypes~"
664 or die "$DATADIR/archetypes~: $!";
665 print $fh Crossfire::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC];
666 }
667
668 {
669 print "writing treasures...\n" if $VERBOSE;
670 open my $fh, ">:utf8", "$DATADIR/treasures~"
671 or die "$DATADIR/treasures~: $!";
672 print $fh $TRS;
673 }
674
675 {
676 print "processing facedata...\n" if $VERBOSE;
677 while (my ($k, $v) = each %FACEINFO) {
678 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n";
679 length $v->{data64} or warn "$k: face has no png64. this will not work very well.\n";
680
681 length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n";
682 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n";
683
684 $v->{chksum32} = Digest::MD5::md5 $v->{data32};
685 $v->{chksum64} = Digest::MD5::md5 $v->{data64};
686
687 if (my $magicmap = $v->{magicmap}) {
688 $magicmap =~ y/A-Z_\-/a-z/d;
689 $v->{magicmap} = $COLOR{$magicmap};
690 }
691
692 delete $v->{arc};
693 }
694
695 print "writing facedata...\n" if $VERBOSE;
696 open my $fh, ">:perlio", "$DATADIR/facedata~"
697 or die "$DATADIR/facedata~: $!";
698
699 print $fh freeze {
700 version => 2,
701 faceinfo => \%FACEINFO,
702 animinfo => \%ANIMINFO,
703 resource => \%RESOURCE,
704 };
705 }
706
707 print "committing files...\n" if $VERBOSE;
708
709 for (qw(archetypes facedata treasures)) {
710 chmod 0644, "$DATADIR/$_~";
711 rename "$DATADIR/$_~", "$DATADIR/$_"
712 or die "$DATADIR/$_: $!";
713 }
714
715 print "archetype data installed successfully.\n";
251 } 716 }
252} 717}
253 718
254Getopt::Long::Configure ("bundling", "no_ignore_case"); 719Getopt::Long::Configure ("bundling", "no_ignore_case");
255GetOptions ( 720GetOptions (

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines